import { RawEntryPluginOptions } from "@rspack/binding";
import { BuiltinPluginName } from "./base";
import { ChunkLoading, EntryRuntime, Filename, LibraryOptions, PublicPath } from "../config";
export type EntryOptions = {
    name?: string;
    runtime?: EntryRuntime;
    chunkLoading?: ChunkLoading;
    asyncChunks?: boolean;
    publicPath?: PublicPath;
    baseUri?: string;
    filename?: Filename;
    library?: LibraryOptions;
};
export declare const EntryPlugin: {
    new (context: string, entry: string, options?: string | EntryOptions | undefined): {
        name: BuiltinPluginName;
        _options: RawEntryPluginOptions;
        raw(): import("@rspack/binding").BuiltinPlugin;
        apply(compiler: import("../Compiler").Compiler): void;
    };
};
