import { BuiltinPlugin, RawConsumeOptions } from "@rspack/binding";
import { Compiler } from "../Compiler";
import { BuiltinPluginName, RspackBuiltinPlugin } from "../builtin-plugin/base";
export type ConsumeSharedPluginOptions = {
    consumes: Consumes;
    shareScope?: string;
};
export type Consumes = (ConsumesItem | ConsumesObject)[] | ConsumesObject;
export type ConsumesItem = string;
export type ConsumesObject = {
    [k: string]: ConsumesConfig | ConsumesItem;
};
export type ConsumesConfig = {
    eager?: boolean;
    import?: false | ConsumesItem;
    packageName?: string;
    requiredVersion?: false | string;
    shareKey?: string;
    shareScope?: string;
    singleton?: boolean;
    strictVersion?: boolean;
};
export declare class ConsumeSharedPlugin extends RspackBuiltinPlugin {
    name: BuiltinPluginName;
    _options: RawConsumeOptions[];
    constructor(options: ConsumeSharedPluginOptions);
    raw(compiler: Compiler): BuiltinPlugin;
}
