/**
 * The following code is modified based on
 * https://github.com/webpack/webpack/tree/4b4ca3bb53f36a5b8fc6bc1bd976ed7af161bd80/lib/util
 *
 * MIT Licensed
 * Author Tobias Koppers @sokra
 * Copyright (c) JS Foundation and other contributors
 * https://github.com/webpack/webpack/blob/main/LICENSE
 */
import type { JsStatsChunk as Chunk } from "@rspack/binding";
import { ChunkGroup } from "../ChunkGroup";
export type Comparator = <T>(arg0: T, arg1: T) => -1 | 0 | 1;
type Selector<A, B> = (input: A) => B;
export declare const concatComparators: (c1: Comparator, c2: Comparator, ...cRest: Comparator[]) => Comparator;
export declare const compareIds: (a: string | number, b: string | number) => -1 | 0 | 1;
export declare const compareChunksById: (a: Chunk, b: Chunk) => -1 | 0 | 1;
export declare const compareChunkGroupsByIndex: (a: ChunkGroup, b: ChunkGroup) => -1 | 0 | 1;
export declare const compareSelect: <T, R>(getter: Selector<T, R>, comparator: Comparator) => Comparator;
export declare const compareNumbers: (a: number, b: number) => 1 | -1 | 0;
export {};
