"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResolveSwcPlugin = void 0;
const path_1 = __importDefault(require("path"));
const compare_versions_1 = require("compare-versions");
class ResolveSwcPlugin {
    apply(compiler) {
        const swcHelperVersion = require("@swc/helpers/package.json").version;
        if ((0, compare_versions_1.compareVersions)(swcHelperVersion, "0.5.0") === -1) {
            throw new Error("Please bump @swc/helpers to ^0.5.0");
        }
        const swcPath = path_1.default.dirname(require.resolve("@swc/helpers/package.json"));
        const refreshPath = path_1.default.dirname(require.resolve("react-refresh"));
        // redirect @swc/helpers to rspack, so user don't have to manual install it
        compiler.options.resolve.alias = {
            "@swc/helpers": swcPath,
            // TODO: DEPRECATED: remove in v0.5.0.
            // it's moved to `@rspack/plugin-react-refresh`, but it still required for `builtins.react` for now.
            "react-refresh": refreshPath,
            ...compiler.options.resolve.alias
        };
    }
}
exports.ResolveSwcPlugin = ResolveSwcPlugin;
